/* Example of I/O port for DIO-D64.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.1.0 11 Jan 2002 by Reed Lai
     Rename DAQ to IXISA.

   v 0.0.0 17 Oct 2001 by Reed Lai
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "ixisa.h"

int main()
{
	int fd;
	char *dev_file;
	ixisa_reg_t reg;
	int x=0;
	unsigned int old = -1;

	dev_file = "/dev/ixisa1";

	/* Open device file */
	fd = open(dev_file, O_RDWR);
	if (fd < 0) {
		printf("Failure of openning device file \"%s.\"\n", dev_file);
		return FAILURE;
	}
	reg.value = x;

	/* DIO */
	while (getchar() == 10) {
		printf("write P[ABCD]: [");
		++x;
		reg.value = x;
		reg.id = IXISA_DIO_A;
		++reg.value;
		if (!ioctl(fd, IXISA_WRITE_REG, &reg))
			printf("%2x", reg.value);
		else printf("--");
		
		reg.id = IXISA_DIO_B;
		++reg.value;
		if (!ioctl(fd, IXISA_WRITE_REG, &reg))
			printf(" %2x", reg.value);
		else printf("--");

		reg.id = IXISA_DIO_C;
		++reg.value;
		if (!ioctl(fd, IXISA_WRITE_REG, &reg))
			printf(" %2x", reg.value);
		else printf("--");

		reg.id = IXISA_DIO_D;
		++reg.value;
		if (!ioctl(fd, IXISA_WRITE_REG, &reg))
			printf(" %2x]\n", reg.value);
		else printf("--]\n");

		printf("read  P[ABCD]: [");
		reg.id = IXISA_DIO_A;
		if (!ioctl(fd, IXISA_READ_REG, &reg))
			printf("%2x", reg.value);
		else printf("--");

		reg.id = IXISA_DIO_B;
		if (!ioctl(fd, IXISA_READ_REG, &reg))
			printf(" %2x", reg.value);
		else printf("--");

		reg.id = IXISA_DIO_C;
		if (!ioctl(fd, IXISA_READ_REG, &reg))
			printf(" %2x", reg.value);
		else printf("--");

		reg.id = IXISA_DIO_D;
		if (!ioctl(fd, IXISA_READ_REG, &reg))
			printf(" %2x]\n", reg.value);
		else printf("--]\n");
		puts("Esc-enter to quit.");
	}

	close(fd);
	return SUCCESS;
}
