/* Definitions for ISO-AD32.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */


#ifndef _ISOAD32_H
#define _ISOAD32_H

#define MODULE_NAME "ixisoad32"

#define IO_RANGE       0x10

/* offset of registers */
#define SR			0x00	// Status Byte
#define FIFO			0x04	// Data_FIFO, COMMAND_FIFO

/* Command sets */
#define CMD_READ_PATTERN	0xa4	// Reserved
#define CMD_READ_CH_SCAN_DATA	0xa5	// read back channel scan data
#define CMD_READ_MUX_CONFIG	0xa6	// read back multiplex and configuration data
#define CMD_READ_SAMPLE_RATE	0xa7	// read back AD pacer sampling rate
#define CMD_READ_CURRENT_AD	0xa8	// read the current active channel AD data
#define CMD_WRITE_MUX_CONFIG	0xa9	// set multiplex and configuration data
#define CMD_WRITE_SAMPLE_RATE	0xaa	// set AD pacer sampling rate
#define CMD_AD_SAMPLE		0xab	// set AD conversion by pacer trigger mode
#define CMD_WRITE_CH_SCAN_DATA	0xac	// set channel scan data
#define CMD_CHANNEL_SCAN_START	0xad	// start channel scan ADs
#define CMD_WRITE_TEST		0xae	// Reserved
#define CMD_READ_TEST		0xaf	// Reserved
#define RESERVED_REG            0x0f

/* mask of registers */
#define SR_MASK   		0xff
#define FIFO_MASK     		0xff

#endif							/* _ISOAD32_H */
