/* Definitions for ISO-DA16.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.0.0  2 May 2003 by Reed Lai
     Bark! Bark! */

#ifndef _ISODA16_H
#define _ISODA16_H

#define MODULE_NAME        "ixisoda16"
#define IO_RANGE           0x10

/* offset of registers */
#define DIGITAL_INPUT_L                  0x00
#define DIGITAL_INPUT_H                  0x01
#define DIGITAL_OUTPUT_L                 0x00
#define DIGITAL_OUTPUT_H                 0x01
#define STATUS_REGISTER			 0x02
#define READ_WRITE_COMMAND_REGISTER      0x03
#define CLEAR_INTERRUPT_SIGNAL_REGISTER	 0x04
#define RESERVED_REG                     0x04

/* Command sets */
#define DA_CMD_MASK			 0x90
#define WRITE_DA_0			 DA_CMD_MASK+0x00
#define WRITE_DA_1			 DA_CMD_MASK+0x01
#define WRITE_DA_2			 DA_CMD_MASK+0x02
#define WRITE_DA_3			 DA_CMD_MASK+0x03
#define SET_PWR_ON			 DA_CMD_MASK+0x04	
#define READ_PWR_ON			 DA_CMD_MASK+0x05

#define TIMER_CMD			 DA_CMD_MASK+0x0b
#define READ_ROM			 DA_CMD_MASK+0x0c
#define WRITE_ROM			 DA_CMD_MASK+0x0d

#define DIL       DIGITAL_INPUT_L
#define DIH       DIGITAL_INPUT_H
#define DOL       DIGITAL_OUTPUT_L
#define DOH       DIGITAL_OUTPUT_H
#define SR	  STATUS_REGISTER
#define RWCR	  READ_WRITE_COMMAND_REGISTER
#define CISR	  CLEAR_INTERRUPT_SIGNAL_REGISTER

/* mask of registers */
#define DIL_MASK       0xff
#define DIH_MASK       0xff
#define DOL_MASK       0xff
#define DOH_MASK       0xff
#define SR_MASK        0x0f
#define RWCR_MASK      0xff
#define CISR_MASK      0xff

int write_reg(ixisa_reg_t * reg, unsigned long int base);

#endif							/* _ISODA16_H */
