/* Definitions for TMC-10.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.1.0 16 Jan 2002 by Reed Lai
     Remove unused symbol INT_MASK_SHIFT_STOP_BIT.

   v 0.0.0 23 Jul 2001 by Reed Lai
     create, blah blah... */

#ifndef _TMC10_H
#define _TMC10_H

#define MODULE_NAME "ixtmc10"

#define IO_RANGE       0x10

/* offset of registers */
#define _8254_COUNTER_0         0x0
#define _8254_COUNTER_1         0x1
#define _8254_COUNTER_2         0x2
#define _8254_CONTROL_WORD      0x3
#define SELECT_8254_CHIP	0x4
#define DIGITAL_OUTPUT_0_TO_7	0x5
#define DIGITAL_INPUT_0_TO_7    0x4
#define DIGITAL_INPUT_8_TO_15   0x5

#define _8254C0  	_8254_COUNTER_0
#define _8254C1  	_8254_COUNTER_1
#define _8254C2  	_8254_COUNTER_2
#define _8254CR  	_8254_CONTROL_WORD
#define _8254CS		SELECT_8254_CHIP
#define DI_A		DIGITAL_INPUT_0_TO_7
#define DI_B	 	DIGITAL_INPUT_8_TO_15
#define DO_A	 	DIGITAL_OUTPUT_0_TO_7

/* mask of registers */
#define _8254C0_MASK  0xff
#define _8254C1_MASK  0xff
#define _8254C2_MASK  0xff
#define _8254CR_MASK  0xff
#define _8254CS_MASK  0x03
#define DI_A_MASK     0xff
#define DI_B_MASK     0xff
#define DO_A_MASK     0xff

#endif							/* _TMC10_H */
