//-----------------------------------------------------------
// MSTEP2.h                                      Chao Chi-Mou
//
// compiled under large mode, Turbo C++
//
// v1.0   3/15/1998
// v2.0  11/26/2000
//    1. add MSTEP2_SET_NC command
//    2. MSTEP2_CSP_MOVE can be change speed while execution
// v3.0   2/10/2001
//    1. add MSTEP2_INTP_LINE02
//    2. add MSTEP2_INTP_CIRCLE02
//    3. add MSTEP2_INTP_ARC02
//    4. add MSTEP2_INTP_STOP
//-----------------------------------------------------------
//#define WIN
//#define WINUSER
//#define DOS

#ifdef WIN
  #define EXPORTS           //for WIN95
#endif

#ifdef WINUSER
  #define EXPORTS extern "C" __declspec (dllexport) //for WIN95 user
#endif

/*#ifdef DOS
  #define EXPORTS   extern    //DOS
  #define CALLBACK            //DOS
#endif*/
//-----------------------------------------------------------
#define YES          1
#define NO           0

#define ON           1
#define OFF          0

#define CW_CCW       0
#define PULSE_DIR    1

#define NORMAL_DIR   0
#define REVERSE_DIR  1

#define FW           0
#define BW           1
#define CW           0
#define CCW          1
#define X_axis       1
#define Y_axis       2  

#define READY 0
#define BUSY  1

#define pi 3.141592654                                                     

//####################################################################
/*#ifndef DOS
 EXPORTS void CALLBACK MSTEP2_INITIAL();
 EXPORTS void CALLBACK MSTEP2_END();
#endif*/

//EXPORTS unsigned char CALLBACK MSTEP2_REGISTRATION(unsigned char cardNo,
                                                   //unsigned int address);
EXPORTS unsigned char CALLBACK MSTEP2_LIMIT_X(unsigned char cardNo);
EXPORTS unsigned char CALLBACK MSTEP2_LIMIT_Y(unsigned char cardNo);
EXPORTS unsigned char CALLBACK MSTEP2_STATUS(unsigned char cardNo);
//----------------------------------------------------
EXPORTS void          CALLBACK MSTEP2_WAIT_X(unsigned char cardNo);
EXPORTS unsigned char CALLBACK MSTEP2_IS_X_STOP(unsigned char cardNo);
EXPORTS void          CALLBACK MSTEP2_WAIT_Y(unsigned char cardNo);
EXPORTS unsigned char CALLBACK MSTEP2_IS_Y_STOP(unsigned char cardNo);
//----------------------------------------------------
EXPORTS void CALLBACK MSTEP2_SET_VAR(unsigned char cardNo,
                            unsigned char set_DDA_cycle,
                            unsigned char set_Acc_Dec,
                            unsigned int set_Low_Speed,
                            unsigned int set_High_Speed);
EXPORTS void CALLBACK MSTEP2_SET_DEFDIR(unsigned char cardNo,
                               unsigned char defdirX,
                               unsigned char defdirY);
EXPORTS void CALLBACK MSTEP2_SET_MODE(unsigned char cardNo,
                             unsigned char modeX,
                             unsigned char modeY);
EXPORTS void CALLBACK MSTEP2_SET_SERVO_ON(unsigned char cardNo,
                                 unsigned char sonX,
                                 unsigned char sonY);
EXPORTS void CALLBACK MSTEP2_SET_NC(unsigned char cardNo, unsigned char sw);
//----------------------------------------------------
EXPORTS void CALLBACK MSTEP2_STOP_X(unsigned char cardNo);
EXPORTS void CALLBACK MSTEP2_STOP_Y(unsigned char cardNo);
EXPORTS void CALLBACK MSTEP2_RESET_SYSTEM(unsigned char cardNo); 
EXPORTS void CALLBACK MSTEP2_STOP_ALL(unsigned char cardNo);
EXPORTS void CALLBACK MSTEP2_EMG_STOP(unsigned char cardNo);
//----------------------------------------------------
EXPORTS void CALLBACK MSTEP2_LSP_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_HSP_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_HSD_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_LSP_PULSE_MOVE(unsigned char cardNo,
                                   unsigned char AXIS,
                                   long pulseN);
EXPORTS void CALLBACK MSTEP2_HSP_PULSE_MOVE(unsigned char cardNo,
                                   unsigned char AXIS,
                                   long pulseN);
EXPORTS void CALLBACK MSTEP2_LSP_MOVE(unsigned char cardNo,
                             unsigned char DIR,
                             unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_HSP_MOVE(unsigned char cardNo,
                             unsigned char DIR,
                             unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_CSP_MOVE(unsigned char cardNo,
                             unsigned char DIR,
                             unsigned char AXIS,
                             unsigned int  speedN);
EXPORTS void CALLBACK MSTEP2_SLOW_DOWN(unsigned char cardNo,
                              unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_SLOW_STOP(unsigned char cardNo,
                              unsigned char AXIS);
EXPORTS void CALLBACK MSTEP2_INTP_PULSE(unsigned char cardNo,
                               int Xpulse, int Ypulse);
EXPORTS void CALLBACK MSTEP2_INTP_LINE(unsigned char cardNo,
                              long Xpulse, long Ypulse);
//----------------------------------------------------
EXPORTS void CALLBACK MSTEP2_INTP_LONG_LINE(unsigned char cardNo,long x, long y,
                                            unsigned int speed);
EXPORTS void CALLBACK MSTEP2_CIRCLE(unsigned char cardNo,
                                    long x, long y, 
                                    unsigned char dir, unsigned int speed);
EXPORTS void CALLBACK MSTEP2_ARC(unsigned char cardNo,
                                 long x, long y, long R, 
                                 unsigned char dir, unsigned int speed);
//------------------------------------------------------------------------
EXPORTS void CALLBACK MSTEP2_INTP_LINE02(unsigned char cardNo,
                                 long x,long y,
                                 unsigned int speed,
                                 unsigned char acc_mode);
EXPORTS void CALLBACK MSTEP2_INTP_CIRCLE02(unsigned char cardNo,
                           long x,
                           long y,
                           unsigned char dir,
                           unsigned int speed,
                           unsigned char acc_mode);
EXPORTS void CALLBACK MSTEP2_INTP_ARC02(unsigned char cardNo,
                        long x,
                        long y,
                        long R,
                        unsigned char dir,
                        unsigned int speed,
                        unsigned char acc_mode);
EXPORTS unsigned char CALLBACK MSTEP2_INTP_STOP();
//------------------------------------------------------------------------
EXPORTS void CALLBACK MSTEP2_GET_CARD(unsigned char cardNo);
